#
# Makefile Template for Tessy
# Compiler: IAR AVR
# Debugger: IAR C-SPY Simulator
# Template Version: 2
#

# Defines to be generated by Tessy:
#
# BUFFER_SIZE             :=
# COMPILER_DEFINES        :=
# COMPILER_INCLUDES       :=
# COMPILER_INSTALL_PATH   :=
# CPU                     :=
# COMPILER_DEFINES        :=
# COMPILER_INCLUDES       :=
# COMPILER_INSTALL_PATH   :=
# CONFIG_HEADER_FILE_FILE :=
# ENDIANESS               :=
# EXEFILE_EXTENSION       :=
# LIBRARY                 :=
# LINKER_FILE             :=
# MODULE_PATH             :=
# MODULE_PATH_DOS         :=
# OBJFILE_EXTENSION       :=
# PROJECTROOT             :=
# TARGET_INSTALL_PATH     :=
# TESSY_BIN               :=
# TESSY_SYS               :=
# TESTOBJECT              :=
# TIMER_FILE              :=
# TARGET_INSTALL_PATH     :=
# TIMER_FILE              :=
# USER_LINK_OPTIONS       :=

#####################################################################
#BEGIN_DEFINES
#####################################################################

#
# Special macros for includes and defines
#
TS_DEF_SEPARATOR :=-D 
define TS_DEFINE
$(subst ;, $(TS_DEF_SEPARATOR),$(1))
endef

TS_INC_SEPARATOR :=-I
define TS_INCLUDE
$(subst ;, $(TS_INC_SEPARATOR),$(1))
endef


TESSY_SYS_DOS   := $(shell ts_pathname -s $(TESSY_SYS))
IAR_HOME        := $(shell ts_pathname -s '$(COMPILER_INSTALL_PATH)')
CSPY_HOME       := $(shell ts_pathname -s '$(TARGET_INSTALL_PATH)')

all    : master slave
master : $(MODULE_PATH)/ts_$(TESTOBJECT)_m.exe
slave  : $(MODULE_PATH_DOS)\ts_$(TESTOBJECT)_s.d90

#
# MASTER & COMM Makefiles
# (you should not need to modify these settings)
#
M_COMM_MAKE := $(TESSY_SYS)/make/master_cspy_gnu_i386.mk
S_COMM_MAKE := $(TESSY_SYS)/src/comm/comm_cspy_iar_avr.mk


#
# SLAVE
# (You may change these settings to use your own compiler/linker options)
#

#PROJECT_COMP :=  -y --initializers_in_flash --root_variables --no_cse --no_inline --no_code_motion --no_cross_call --no_clustering --no_tbaa --debug -DENABLE_BIT_DEFINITIONS -e --eeprom_size 2048 --dlib --dlib_config -On
#POJECT_LINK :=  -z -l C:\TestData\Gassecure\GS01-SIL\main\Debug\List\main.map -xmsn -IC:\Program Files (x86)\IAR Systems\Embedded Workbench 6.5\avr\LIB\ -f C:\TestData\Gassecure\GS01-SIL\main\lnkxm128a1s.xcl -D_..X_HEAP_SIZE=0 -D_..X_TINY_HEAP_SIZE=0 -D_..X_NEAR_HEAP_SIZE=20 -D_..X_FAR_HEAP_SIZE=1000 -D_..X_HUGE_HEAP_SIZE=1000 -D_..X_CSTACK_SIZE=400 -D_..X_RSTACK_SIZE=C0 -D_..X_FLASH_CODE_END=1FFFF -D_..X_FLASH_BASE=_..X_INTVEC_SIZE -H1895 -h(CODE)0-(_..X_INTVEC_SIZE-1) -D_..X_EXT_SRAM_BASE=_..X_SRAM_END -D_..X_EXT_SRAM_SIZE=0 -D_..X_EXT_ROM_BASE=_..X_SRAM_END -D_..X_EXT_ROM_SIZE=0 -D_..X_EXT_NV_BASE=_..X_SRAM_END -D_..X_EXT_NV_SIZE=0 -D_..X_CSTACK_BASE=_..X_SRAM_BASE -D_..X_CSTACK_END=_..X_SRAM_END -D_..X_RSTACK_BASE=_..X_SRAM_BASE -D_..X_RSTACK_END=_..X_SRAM_END -rt -Ointel-extended,3=C:\TestData\Gassecure\GS01-SIL\main\Debug\Exe\gs-sil.hex -s __program_start C:\Program Files (x86)\IAR Systems\Embedded Workbench 6.5\avr\LIB\DLIB\dlAVR-6s-xmega-n.r90


S_COMP_OPTIONS := -ms --cpu=$(CPU) -e -z3 --debug --no_cse --no_inline --no_code_motion --no_cross_call --no_clustering --no_tbaa \
                  -DENABLE_BIT_DEFINITIONS -D TESSY -D TS_SLAVE -D TS_CSPY -D TS_HAVE_FLOAT32 --dlib_config "$(CONFIG_HEADER_FILE)"

S_LINK_OPTIONS := -I$(IAR_HOME)\lib\dlib\ -f "$(LINKER_FILE)" -rt -s __program_start "$(LIBRARY)"
S_INCLUDES     := -I$(IAR_HOME)\inc\ -I$(IAR_HOME)\inc\dlib\ -I$(IAR_HOME)\lib\dlib\ -I$(TESSY_SYS_DOS)\include\tessy\comm\ -I$(MODULE_PATH_DOS)\

S_CC           := $(IAR_HOME)\bin\iccavr
S_LINK         := $(IAR_HOME)\bin\xlink
S_OBJECTS      := $(MODULE_PATH_DOS)\tslows_cspy.r90 $(MODULE_PATH_DOS)\tstcomm.r90 $(MODULE_PATH_DOS)\tscoml.r90
S_STUB_OBJECT  := $(MODULE_PATH_DOS)\ts_$(TESTOBJECT)_stubs.r90
S_UC_OBJECT    := $(MODULE_PATH_DOS)\ts_$(TESTOBJECT)_usr.r90

#####################################################################
#END_DEFINES
#####################################################################

#####################################################################
#BEGIN_SOURCE
#####################################################################

#
# Template rules
#
$(MODULE_PATH_DOS)\ts_src$$(SOURCENUMBER)$(OBJFILE_EXTENSION): $(MODULE_PATH_DOS)\ts_src$$(SOURCENUMBER).c
	$(S_CC) -o $@ $(S_INCLUDES) $(call TS_INCLUDE,$(USER_INCLUDES$$(SOURCENUMBER))) $(S_COMP_OPTIONS) \
		$(call TS_DEFINE,$(USER_DEFINES$$(SOURCENUMBER))$(S_COM_OPTIONS)) \
		$(USER_COMP_OPTIONS$$(SOURCENUMBER)) "$<"


#####################################################################
#END_SOURCE
#####################################################################

#####################################################################
#BEGIN_TARGETS
#####################################################################


# Don't show action lines
# COMPILE USERCODE / STUBS
#
$(S_UC_OBJECT) : $(MODULE_PATH_DOS)\ts_$(TESTOBJECT)_usr.c
	$(S_CC) -o $@ $(S_INCLUDES) $(S_COMP_OPTIONS) $<

$(S_STUB_OBJECT) : $(MODULE_PATH_DOS)\ts_$(TESTOBJECT)_stubs.c
	$(S_CC) -o $@ $(S_INCLUDES) $(S_COMP_OPTIONS) $<

#
# COMPILE/LINK MASTER
#

include $(M_COMM_MAKE)


#
# COMPILE SLAVE COMMUNICATION MODULES

include $(S_COMM_MAKE)


#
# COMPILE/LINK SLAVE
#
$(MODULE_PATH_DOS)\ts_$(TESTOBJECT)_s.r90 : $(MODULE_PATH_DOS)\ts_$(TESTOBJECT)_s.c
	@echo *
	@echo ***** Compiling Slave *****
	$(S_CC) -o $@ $(S_INCLUDES) $(S_COMP_OPTIONS) $<


$(MODULE_PATH_DOS)\ts_$(TESTOBJECT)_s.d90 : $(MODULE_PATH_DOS)\ts_$(TESTOBJECT)_s.r90 \
															$(S_SRC_OBJECTS) \
															$(S_UC_OBJECT) \
															$(S_STUB_OBJECT) \
															$(S_OBJECTS)
	@echo *
	@echo ***** Linking Slave *****
	$(S_LINK) $(MODULE_PATH_DOS)\ts_$(TESTOBJECT)_s.r90 $(S_STUB_OBJECT) $(S_UC_OBJECT) \
   $(S_SRC_OBJECTS) $(USER_LINK_OPTIONS) $(S_OBJECTS) -o "$@" $(S_LINK_OPTIONS)
	@-rm "$(MODULE_PATH)"/*.r90


#####################################################################
#END_TARGETS
#####################################################################












